# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#yiwang: set test to true. 
##%bcond_without test
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-reflect/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-reflect
Version:        2.0.4
Release:        2%{?dist}
Epoch:          0
Summary:        JBoss Reflect
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/jboss-reflect/tags/2.0.4.GA/ jboss-reflect-2.0.4
# Exported revision 113176
# tar czf jboss-reflect-2.0.4.tar.gz jboss-reflect-2.0.4
Source0:        jboss-reflect-%{version}.tar.gz
Source1:        jboss-reflect-jpp-depmap.xml
Source2:        jboss-reflect-settings.xml
Source3:        jboss-reflect-component-info.xml
# Patch pom.xml to use jboss-parent 4 instead of 5
Patch0:         %{name}-pom.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  codehaus-stax-api
BuildRequires:  jboss-common-beans
BuildRequires:  jboss-test
BuildRequires:  junit4
BuildRequires:  jboss-profiler

BuildRequires:  ant-junit
BuildRequires:  javassist
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-parent

Requires:  java >= 0:1.5.0
Requires:  javassist
Requires:  jboss-common-beans
Requires:  jboss-common-core
Requires:  jboss-common-logging-spi

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss reflect.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 -b .sav0
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm} -f

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

#%if !%with test
# remove dependencies for test
#sed -i "68,88 d" pom.xml
#%endif 

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dskip-enforce \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file://$(pwd)/maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss %{name} %{namedversion} JPP %{name}
install -m 644 target/%{name}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-reflect.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-reflect.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-reflect.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/jboss-reflect-sources.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-reflect-sources.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{version}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Jul 09 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-2
- Rebuild

* Mon Jul 09 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-1
- Upgrade to 2.0.4

* Mon Jan 17 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-7
- Add patch to use jboss-parent 4
- Change BR junit44 to junit4

* Mon Jan 17 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-6
- Rebuild for MEAD

* Wed Dec 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-5
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR codehaus-stax-api, maven-deploy-plugin, maven-surefire-provider-junit4

* Tue May 25 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.3-4
- Upgrade to 2.0.3.GA
- Add pom.xml to repolib

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.2-3.2.2.1
- rebuilt

* Tue Apr 20 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.2-3.2.2
- Rebuild

* Wed Jan 27 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.2-3.2.1
- Rebuild with dependency to jboss-test (enabled test flag) 

* Fri Jan 15 2010 Yong Yang <yyang@redhat.com> 0:2.0.2-3.2
- Remove test dependencies in pom.xml when building without test

* Thu Jan 14 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.2-3.1
- Comment BR:jboss-test because of circular dependencies 

* Wed Jun 17 2009 David Walluck <dwalluck@redhat.com> 0:2.0.2-3
- fix repolib location

* Tue Jun 16 2009 David Walluck <dwalluck@redhat.com> 0:2.0.2-2
- add repolib

* Mon Jun 08 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.0.2-1.jpp5
- first release
